include "basics/pts.ma".
include "connectives.ma".
include "leibniz.ma".
include "logic.ma".
axiom nat : Type[0].
axiom S : nat -> nat.
axiom filter_nat_type : \forall return_ : Type[0] . (nat -> return_) -> nat -> return_.
axiom axiom_filter_nat_type_S : \forall return_type. \forall (return_:nat -> return_type). \forall (n:nat). (equal) (return_type) ((filter_nat_type) (return_type) return_ ((S)  n)) (return_ ((S)  n)).
definition eq_filter_nat_type_S : \forall return_type. \forall (return_:nat -> return_type). \forall (n:nat). (leibniz) (return_type) ((filter_nat_type) (return_type) return_ ((S)  n)) (return_ ((S)  n)) := \lambda return_type : Type[0]. \lambda return_ : nat -> return_type. \lambda n : nat. ((((equal_leibniz) (return_type)) ((filter_nat_type) (return_type) return_ ((S)  n))) (return_ ((S)  n))) ((((axiom_filter_nat_type_S) (return_type)) (return_)) (n)).
definition sym_eq_filter_nat_type_S : \forall return_type. \forall (return_:nat -> return_type). \forall (n:nat). (leibniz) (return_type) (return_ ((S)  n)) ((filter_nat_type) (return_type) return_ ((S)  n)) := \lambda return_type : Type[0]. \lambda return_ : nat -> return_type. \lambda n : nat. ((((sym_leibniz) (return_type)) ((filter_nat_type) (return_type) return_ ((S)  n))) (return_ ((S)  n))) ((((eq_filter_nat_type_S) (return_type)) (return_)) (n)).
axiom plus : nat -> nat -> nat.
axiom times : nat -> nat -> nat.
axiom times_body : nat -> nat -> nat.
axiom axiom_times : \forall (n:nat). (equal) (nat -> nat) ((times)  n) ((filter_nat_type) (nat -> nat) (times_body)  n).
definition eq_times : \forall (n:nat). (leibniz) (nat -> nat) ((times)  n) ((filter_nat_type) (nat -> nat) (times_body)  n) := \lambda n : nat. ((((equal_leibniz) (nat -> nat)) ((times)  n)) ((filter_nat_type) (nat -> nat) (times_body)  n)) ((axiom_times) (n)).
definition sym_eq_times : \forall (n:nat). (leibniz) (nat -> nat) ((filter_nat_type) (nat -> nat) (times_body)  n) ((times)  n) := \lambda n : nat. ((((sym_leibniz) (nat -> nat)) ((times)  n)) ((filter_nat_type) (nat -> nat) (times_body)  n)) ((eq_times) (n)).
axiom axiom_times_body_S : \forall (n:nat). (equal) (nat -> nat) ((times_body)  ((S)  n)) (\lambda m : nat. (plus)  m ((times)  n m)).
definition eq_times_body_S : \forall (n:nat). (leibniz) (nat -> nat) ((times_body)  ((S)  n)) (\lambda m : nat. (plus)  m ((times)  n m)) := \lambda n : nat. ((((equal_leibniz) (nat -> nat)) ((times_body)  ((S)  n))) (\lambda m : nat. (plus)  m ((times)  n m))) ((axiom_times_body_S) (n)).
definition sym_eq_times_body_S : \forall (n:nat). (leibniz) (nat -> nat) (\lambda m : nat. (plus)  m ((times)  n m)) ((times_body)  ((S)  n)) := \lambda n : nat. ((((sym_leibniz) (nat -> nat)) ((times_body)  ((S)  n))) (\lambda m : nat. (plus)  m ((times)  n m))) ((eq_times_body_S) (n)).
definition times_Sn_m : \forall (n:nat). \forall (m:nat). (eq) (nat) ((plus)  m ((times)  n m)) ((times)  ((S)  n) m) := \lambda n : nat. \lambda m : nat. (((sym_eq_times) ((S)  n)) (\lambda y : nat -> nat. (eq) (nat) ((plus)  m ((times)  n m)) (y m))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) ((times_body) )) (n)) (\lambda y : nat -> nat. (eq) (nat) ((plus)  m ((times)  n m)) (y m))) ((((sym_eq_times_body_S) (n)) (\lambda y : nat -> nat. (eq) (nat) ((plus)  m ((times)  n m)) (y m))) (((refl) (nat)) ((plus)  m ((times)  n m))))).
